## ukui-screensaver-3.0.2-10.src.tar.gz

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
project(ukui-screensaver)

find_package(Qt5 COMPONENTS Core Widgets DBus X11Extras Xml Svg)
find_package(PkgConfig REQUIRED)
find_package(OpenCV REQUIRED)
find_package(PkgConfig)
pkg_check_modules(GIOUNIX2 REQUIRED gio-unix-2.0)
pkg_check_modules(GLIB2 REQUIRED glib-2.0 gio-2.0)

set(TS_FILES
	${CMAKE_CURRENT_SOURCE_DIR}/i18n_ts/zh_CN.ts
	${CMAKE_CURRENT_SOURCE_DIR}/i18n_ts/es.ts
	${CMAKE_CURRENT_SOURCE_DIR}/i18n_ts/fr.ts
	${CMAKE_CURRENT_SOURCE_DIR}/i18n_ts/pt.ts
	${CMAKE_CURRENT_SOURCE_DIR}/i18n_ts/ru.ts
        ${CMAKE_CURRENT_SOURCE_DIR}/i18n_ts/tr.ts
	)
add_custom_command(
	OUTPUT ${TS_FILES}
	COMMAND lupdate src/ screensaver/ -ts ${TS_FILES}
	WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
	)
add_custom_target(
	i18n_ts
	DEPENDS ${TS_FILES}
	)
add_compile_options(-fPIC)

#set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Werror")
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_INSTALL_PREFIX /usr)

set(Debug ON)
if(Debug)
    set(CMAKE_BUILD_TYPE "Debug")                                                                                                     
endif()

#add_subdirectory(BioAuth)
add_subdirectory(BiometricAuth)
add_subdirectory(VirtualKeyboard)
add_subdirectory(src)
add_subdirectory(i18n_ts)
add_subdirectory(data)
add_subdirectory(screensaver)
add_subdirectory(Common)

add_dependencies(ukui-screensaver-dialog BiometricAuth VirtualKeyboard Common)
add_dependencies(ukui-screensaver-default Common)

=== screensaver/CMakeLists.txt ===
pkg_check_modules(X11 REQUIRED x11)
pkg_check_modules(XTST REQUIRED xtst)
pkg_check_modules(QGS REQUIRED gsettings-qt)

include_directories(${PROJECT_BINARY_DIR})
include_directories(${PROJECT_SOURCE_DIR}/Common)

include_directories(
	${X11_INCLUDE_DIRS}
        ${XTST_INCLUDE_DIRS}
	${QGS_INCLUDE_DIRS}
	)

set(EXTRA_LIBS
	${EXTRA_LIBS}
	${X11_LIBRARIES}
        ${XTST_LIBRARIES}
	${QGS_LIBRARIES}
	Common
	)
qt5_add_resources(screensaver_SRC
	default.qrc
	)

qt5_wrap_cpp(screensaver_SRC
    chinesedate.h
    screensaver.h
    mbackground.h
    cyclelabel.h
    scconfiguration.h
    sleeptime.h
    )
set(screensaver_SRC
    ${screensaver_SRC}
    main.cpp
    chinesedate.cpp
    mbackground.cpp
    screensaver.cpp
    cyclelabel.cpp
    scconfiguration.cpp
    sleeptime.cpp
    )
add_executable(ukui-screensaver-default ${screensaver_SRC})
target_link_libraries(ukui-screensaver-default Qt5::Core Qt5::Widgets Qt5::X11Extras Qt5::Xml ${EXTRA_LIBS})

install(TARGETS
	ukui-screensaver-default
	DESTINATION lib/ukui-screensaver)

install(FILES
        language/screensaver-zh_CN.ini 
	language/screensaver-en_US.ini
	language/screensaver-jd.ini
        DESTINATION share/ukui-screensaver/language)

=== src/CMakeLists.txt ===
pkg_check_modules(X11 REQUIRED x11)
pkg_check_modules(XTST REQUIRED xtst)
pkg_check_modules(XCB REQUIRED xcb)
pkg_check_modules(QGS REQUIRED gsettings-qt)

find_library(PAM_LIBRARIES pam)

include_directories(${PROJECT_BINARY_DIR})
include_directories(${PROJECT_SOURCE_DIR}/VirtualKeyboard/src)
include_directories(${PROJECT_SOURCE_DIR}/BiometricAuth)
include_directories(${PROJECT_SOURCE_DIR}/Common)

include_directories(
	${X11_INCLUDE_DIRS}
	${XTST_INCLUDE_DIRS}
	${XCB_INCLUDE_DIRS}
	${QGS_INCLUDE_DIRS}
	)

set(EXTRA_LIBS
	${EXTRA_LIBS}
	${PAM_LIBRARIES}
	${X11_LIBRARIES}
	${XTST_LIBRARIES}
	${XCB_LIBRARIES}
	${QGS_LIBRARIES}
        -lrt
	)

qt5_wrap_ui(dialog_SRC
        lockwidget.ui
        )

qt5_add_resources(dialog_SRC
	assets.qrc
	)

# 头文件中包含了Xlib.h，需要单独拿出来处理，不知道原因
qt5_wrap_cpp(dialog_SRC
	fullbackgroundwidget.h
	lockwidget.h
	authdialog.h
	screensaverwidget.h
	auth.h
	auth-pam.h
	screensaver.h
	xeventmonitor.h
	monitorwatcher.h
	configuration.h
    users.h
    displaymanager.h
	iconedit.h
	powermanager.h
    logind.h
    pam-tally.h
	)

set(dialog_SRC
	${dialog_SRC}
	ukui-screensaver-dialog.cpp
	fullbackgroundwidget.cpp
	lockwidget.cpp
	authdialog.cpp
	screensaverwidget.cpp
	auth-pam.cpp
	xeventmonitor.cpp
	monitorwatcher.cpp
	grab-x11.cpp
	configuration.cpp
	screensaver.cpp
	powermanager.cpp
	users.cpp
	displaymanager.cpp
	iconedit.cpp
    logind.cpp
    pam-tally.cpp
	)
add_executable(ukui-screensaver-dialog ${dialog_SRC})

target_link_libraries(ukui-screensaver-dialog
	Qt5::Core
	Qt5::Widgets
	Qt5::DBus
	Qt5::Svg
	Qt5::X11Extras
	${EXTRA_LIBS}
        BiometricAuth 
	VirtualKeyboard 
	Common
	)

qt5_add_dbus_adaptor(backend_SRC
    org.ukui.ScreenSaver.xml
    interface.h
    Interface
    )

qt5_wrap_cpp(backend_SRC
    interface.h
    sessionwatcher.h
    logind.h
    )
set(backend_SRC
    ${backend_SRC}
    ukui-screensaver-backend.cpp
    interface.cpp
    sessionwatcher.cpp
    logind.cpp
    )
add_executable(ukui-screensaver-backend ${backend_SRC})
target_link_libraries(ukui-screensaver-backend Qt5::Core Qt5::DBus ${QGS_LIBRARIES})

set(command_SRC
    ukui-screensaver-command.cpp
    )
add_executable(ukui-screensaver-command ${command_SRC})
target_link_libraries(ukui-screensaver-command Qt5::Core Qt5::DBus)

set(checkpass_SRC
    ukui-screensaver-checkpass.cpp
    )
add_executable(ukui-screensaver-checkpass ${checkpass_SRC})
target_link_libraries(ukui-screensaver-checkpass ${PAM_LIBRARIES})

install(TARGETS
    ukui-screensaver-dialog
    ukui-screensaver-backend
    ukui-screensaver-command
    ukui-screensaver-checkpass
    DESTINATION bin)

#set(test-act_SRC
#	users.cpp
#	test-accounts.cpp
#	)
#add_executable(test-accounts ${test-act_SRC})
#target_link_libraries(test-accounts Qt5::Core Qt5::DBus)

=== debian/changelog ===
ukui-screensaver (3.0.2-1) unstable; urgency=medium

  * New upstream release.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Tue, 17 Aug 2021 20:41:03 +0800

ukui-screensaver (3.0.1-1) unstable; urgency=medium

  * New upstream bugfix release.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Sun, 27 Sep 2020 14:47:09 +0800

ukui-screensaver (3.0.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/control: bump standards-version to 4.5.0.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Wed, 12 Aug 2020 12:01:14 +0000

ukui-screensaver (2.1.1-1) unstable; urgency=medium

  * New upstream bugfix release:
    - Fix that long press the enter key will cause the crash.
    - Set default face to avoid empty frame.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Mon, 13 Apr 2020 16:33:05 +0800

ukui-screensaver (2.1.0-1) unstable; urgency=medium

  * New upstream bugfix release.
    - Fix the problem that the on-screen keyboard
      is displayed incorrectly when dual screen.
    - Fix the issue that the second-user cannot
      use biometrics when switching users to lock the screen.
    - Fix the lock screen issue when root user switched tty
      back and forth.
    - Keep lock screen stays on top.
    - Fix that in extended mode, login interface cannot be switched
      between two monitors with the mouse.
    * Fix the problem that the first user could not lock
      the screen when logging in two users at the same time
      by user switching.
  * debian:
    - Bump standards-vertion to 4.5.0.
    - Remove the missing file from copyright.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Thu, 26 Mar 2020 21:19:04 +0800

ukui-screensaver (2.0.10-1) unstable; urgency=medium

  * New upstream release.
  * debian/{compat,control}
    - use debhelper-compat, bump to compat level version 12.
  * debian/control:
    - Bump standards-version to 4.4.1. No changes needed.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Wed, 11 Dec 2019 09:06:24 +0800

ukui-screensaver (2.0.9-0ubuntu1) eoan; urgency=medium

  * Bugfix only:
    - Don't lock when in live session. (LP: #1842855)
    - Fix the wrong background. (LP: #1836292)
    - Fix the wrong path of ukui-screensaver.menu.
    - Fix the errors when running Kydroid.
    - Fix the focus issues.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Mon, 07 Oct 2019 20:10:00 +0800

ukui-screensaver (2.0.7-1) unstable; urgency=medium

  [ Liu Yuanpeng ]
  * Set background widget on top. (LP: #1828955)
  * Set default background color. (LP: #1828982)
  * Fix that sometimes can't enter password.

  [ handsome_feng ]
  * Bump standards-vertion to 4.4.0.
  * Drop mate-session-manager.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Wed, 14 Aug 2019 09:04:48 +0800

ukui-screensaver (2.0.6-0ubuntu1) disco; urgency=medium

  * Bugfix only:
    - Fix the bug that the screensaver is still activated when
      sessionIdleOption is unchecked.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Fri, 12 Apr 2019 14:32:26 +0800

ukui-screensaver (2.0.5-0ubuntu1) disco; urgency=medium

  * Bugfix only:
    - Fix the wrong activated condition. (LP: #1822037)

 -- handsome_feng <jianfengli@ubuntukylin.com>  Thu, 28 Mar 2019 16:38:31 +0800

ukui-screensaver (2.0.4-1) experimental; urgency=medium

  * Add /etc/pam.d/ukui-screensaver-qt.
  * Generate dbus adaptor in CMake file.
  * Bugfix: failed to switch to biometric authentication if no default device.
  * Bugfix: stop authentication before suspend and start it after wake up.
  * Bugfix: not activated when idel-activation-enabled is false.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Fri, 22 Mar 2019 11:38:03 +0800

ukui-screensaver (2.0.3-1) unstable; urgency=medium

  * Change UI.
  * Add virtual keyboard.
  * Add button for switching user.
  * Remove Xext dependency.
  * Auto retry if identify failed.
  * Set the button's cursor to PointingHand.
  * Add waiting movie after respond.
  * Show black if the saver's path doesn't exist.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Sat, 05 Jan 2019 16:10:25 +0800

ukui-screensaver (2.0.2-1) unstable; urgency=medium

  * Add fr.po, pt.po, ru.po.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Tue, 23 Oct 2018 14:14:18 +0800

ukui-screensaver (2.0.1-1) UNRELEASED; urgency=medium

  * Update translation.
  * Change Architecture to any.
  * New design implemneted with Qt5.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Sat, 29 Sep 2018 17:01:12 +0800

ukui-screensaver (1.1.2-1) UNRELEASED; urgency=medium

  * Set object name of auth_prompt_entry.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Tue, 26 Jun 2018 16:10:33 +0800

ukui-screensaver (1.1.1-1) UNRELEASED; urgency=medium

  * Fix a translation file typo
  * Add "Modified by:" to three files

 -- handsome_feng <jianfengli@ubuntukylin.com>  Sat, 17 Mar 2018 14:01:48 +0800

ukui-screensaver (1.1.0-1) UNRELEASED; urgency=medium

  * Optimize the lock-dialog rendering process.
  * Remove frame shadow from the lock-dialog.
  * Add CSS stylesheets to the unlock button.
  * Migrate gtk-2.0 to gtk-3.0.
  * Update translation files.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Tue, 27 Feb 2018 15:41:35 +0800

ukui-screensaver (1.0.3-1) UNRELEASED; urgency=medium

  * [Fixed] screensaver-preferences can't preview "Blank Screen" correctly.
  * [Improved] Change the unlock arrow to button.
  * [Improved] Set the font style of username label.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Wed, 13 Sep 2017 09:14:54 +0800

ukui-screensaver (1.0.2-2) unstable; urgency=medium

  * Use tracker.d.o team address (Closes: #899718)

 -- Aron Xu <aron@debian.org>  Mon, 09 Jul 2018 17:09:48 +0800

ukui-screensaver (1.0.2-1) unstable; urgency=medium

  * Initial release (Closes: #872968)

 -- Aron Xu <aron@debian.org>  Sat, 26 Aug 2017 15:26:45 +0800

=== PKGBUILD ===
# Maintainer: Felix Yan <felixonmars@archlinux.org>

pkgname=ukui-screensaver
pkgver=3.0.2
pkgrel=10
pkgdesc="Screensaver for UKUI desktop environment"
arch=('x86_64')
license=('GPL')
url="https://github.com/ukui/ukui-screensaver"
groups=('ukui')
depends=('dconf' 'gsettings-qt' 'libxtst' 'opencv' 'qt5-svg' 'qt5-x11extras')
makedepends=('cmake' 'qt5-tools')
source=("$pkgname-$pkgver.tar.gz::https://github.com/ukui/ukui-screensaver/archive/v$pkgver.tar.gz"
         qt-5.15.10.patch)
sha512sums=('5d7af2f2d2903bf5f6e337223e9f4a29069e76b3aec448289efbec16de1e24a0c040ad537aef15bf532abc4305e3bb618950bdaf8346de217408126258643596'
            'f28d9405d4124255be41e52b3fe3c9e752c4f548b56ad4b4114a17ff24071d252ccd2e51c02f642eb09e756d550da3d473533ec0718055d615a82ffa775ae492')

prepare() {
  mkdir -p build
  # https://github.com/ukui/ukui-screensaver/issues/65
  cp /etc/pam.d/login $pkgname-$pkgver/data/ukui-screensaver-qt
  sed -e 's|gio-unix-2.0|glib-2.0|' -i $pkgname-$pkgver/BiometricAuth/giodbus.cpp
  # Fix build with Qt 5.15.10
  patch -d $pkgname-$pkgver -p1 < qt-5.15.10.patch
}

build() {
  cd build
  cmake ../$pkgname-$pkgver \
    -DCMAKE_INSTALL_PREFIX=/usr \
    -DCMAKE_POLICY_VERSION_MINIMUM=3.5
  make
}

package() {
  cd build
  make DESTDIR="$pkgdir" install
}

=== debian/control ===
Source: ukui-screensaver
Section: x11
Priority: optional
Maintainer: Kylin Team <team+kylin@tracker.debian.org>
Uploaders: Aron Xu <aron@debian.org>,
           handsome_feng <jianfengli@ubuntukylin.com>
Build-Depends: debhelper-compat (= 12),
               cmake (>=2.6),
               qtbase5-dev,
               libqt5x11extras5-dev,
               libqt5svg5-dev,
               libpam0g-dev,
               qttools5-dev,
               qttools5-dev-tools,
               libglib2.0-dev,
               libopencv-dev,
               libx11-dev,
               libxtst-dev,
               libgsettings-qt-dev
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://www.github.com/ukui/ukui-screensaver
Vcs-Git: https://github.com/ukui/ukui-screensaver.git
Vcs-Browser: https://github.com/ukui/ukui-screensaver

Package: ukui-screensaver
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
         ukui-session-manager,
         mate-desktop-common
Replaces: ukui-screensaver-common (<< 2.0.0)
Description: Screensaver for UKUI desktop environment
 A simple and lightweight screensaver written by Qt5.
 The screensaver supports biometric auhentication which is
 provided by biometric-auth service.
